## docopt.cpp 0.6.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(docopt.cpp VERSION 0.6.1)

include(GNUInstallDirs)

#============================================================================
# Settable options
#============================================================================
option(WITH_TESTS "Build tests." OFF)
option(WITH_EXAMPLE "Build example." OFF)
option(USE_BOOST_REGEX "Replace std::regex with Boost.Regex" OFF)

#============================================================================
# Internal compiler options
#============================================================================
# C++ standard
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
if(NOT CMAKE_CXX_STANDARD OR CMAKE_CXX_STANDARD LESS 11)
	set(CMAKE_CXX_STANDARD 11)
endif()

# Suppression of "unknown pragma" warning on GCC
if(CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unknown-pragmas") # Code uses #pragma mark
endif()

#============================================================================
# Sources & headers
#============================================================================
set(docopt_SOURCES docopt.cpp)
set(docopt_HEADERS
		docopt.h
		docopt_private.h
		docopt_util.h
		docopt_value.h
		)

#============================================================================
# Compile targets
#============================================================================
if(MSVC OR XCODE)
    # MSVC requires __declspec() attributes, which are achieved via the 
    # DOCOPT_DLL and DOCOPT_EXPORTS macros below. Since those macros are only
    # defined when building a shared library, we must build the shared and
    # static libraries completely separately.
    # Xcode does not support libraries with only object files as sources.
    # See https://cmake.org/cmake/help/v3.0/command/add_library.html?highlight=add_library
    add_library(docopt SHARED ${docopt_SOURCES} ${docopt_HEADERS})
    add_library(docopt_s STATIC ${docopt_SOURCES} ${docopt_HEADERS})
else()
    # If not using MSVC or Xcode, we will create an intermediate object target
    # to avoid compiling the source code twice.
    add_library(docopt_o OBJECT ${docopt_SOURCES} ${docopt_HEADERS})
    set_target_properties(docopt_o PROPERTIES POSITION_INDEPENDENT_CODE TRUE)

    add_library(docopt SHARED $<TARGET_OBJECTS:docopt_o>)
    add_library(docopt_s STATIC $<TARGET_OBJECTS:docopt_o>)
endif()

target_include_directories(docopt PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}> $<INSTALL_INTERFACE:include/docopt>)
target_include_directories(docopt_s PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}> $<INSTALL_INTERFACE:include/docopt>)

if(MSVC)
    # DOCOPT_DLL: Must be specified when building *and* when using the DLL.
    #             That's what the "PUBLIC" means.
    # DOCOPT_EXPORTS: Must use __declspec(dllexport) when building the DLL.
    #                 "PRIVATE" means it's only defined when building the DLL.
    target_compile_definitions(docopt PUBLIC  DOCOPT_DLL
                                      PRIVATE DOCOPT_EXPORTS)
endif()

if(NOT MSVC)
	set_target_properties(docopt PROPERTIES OUTPUT_NAME docopt)
	set_target_properties(docopt_s PROPERTIES OUTPUT_NAME docopt)
endif()

if(USE_BOOST_REGEX)
	add_definitions("-DDOCTOPT_USE_BOOST_REGEX")
	# This is needed on Linux, where linking a static library into docopt.so
	# fails because boost static libs are not compiled with -fPIC
	set(Boost_USE_STATIC_LIBS OFF)
    find_package(Boost 1.53 REQUIRED COMPONENTS regex)
    include_directories(${Boost_INCLUDE_DIRS})
    target_link_libraries(docopt ${Boost_LIBRARIES})
	if(WITH_STATIC)
		target_link_libraries(docopt_s ${Boost_LIBRARIES})
	endif()
endif()

#============================================================================
# Examples
#============================================================================
if(WITH_EXAMPLE)
	add_executable(docopt_example examples/naval_fate.cpp)
	target_link_libraries(docopt_example docopt)
endif()

#============================================================================
# Tests
#============================================================================
if(WITH_TESTS)
	set(TESTPROG "${CMAKE_CURRENT_BINARY_DIR}/run_testcase")
	set(TESTCASES "${PROJECT_SOURCE_DIR}/testcases.docopt")
	add_executable(run_testcase run_testcase.cpp)
	target_link_libraries(run_testcase docopt)
	configure_file(
			"${PROJECT_SOURCE_DIR}/run_tests.py"
			"${CMAKE_CURRENT_BINARY_DIR}/run_tests"
			ESCAPE_QUOTES
	)
	add_test("Testcases docopt" ${TESTPROG})
endif()

#============================================================================
# Install
#============================================================================
set(export_name "docopt-targets")

# Runtime package
install(TARGETS docopt EXPORT ${export_name} DESTINATION ${CMAKE_INSTALL_LIBDIR})

# Development package
install(TARGETS docopt_s EXPORT ${export_name} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${docopt_HEADERS} DESTINATION include/docopt)

# CMake Package
include(CMakePackageConfigHelpers)
write_basic_package_version_file("${PROJECT_BINARY_DIR}/docopt-config-version.cmake" COMPATIBILITY SameMajorVersion)
install(FILES docopt-config.cmake ${PROJECT_BINARY_DIR}/docopt-config-version.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/docopt")
install(EXPORT ${export_name} DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/docopt")

#============================================================================
# CPack
#============================================================================
set(CPACK_PACKAGE_NAME "docopt")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "")
set(CPACK_RPM_PACKAGE_REQUIRES "")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Beautiful command line interfaces")
set(CPACK_PACKAGE_VENDOR "Jared Grubb")
set(CPACK_PACKAGE_CONTACT ${CPACK_PACKAGE_VENDOR})
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.rst")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE-MIT")
set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
set(CPACK_DEBIAN_PACKAGE_SECTION "Development")
set(CPACK_RPM_PACKAGE_GROUP "Development/Libraries")
set(CPACK_RPM_PACKAGE_LICENSE "MIT")
set(CPACK_STRIP_FILES TRUE)
include(CPack)

=== debian/changelog ===
docopt.cpp (0.6.2-2) unstable; urgency=medium

  * Switch from git-dpm to gbp
    - Drop git-dpm configuration
    - Unapply patch queue
    - Add gbp configuration
  * Refresh and drop numbering of the patch queue
  * Fixup the VCS-Browser URI
  * Support the nocheck build profile
    - Add versioned b-dep on dpkg-dev
    - Mark test b-deps as !nocheck
    - Use DEB_BUILD_PROFILES in nocheck guards
  * Run the tests using Python 3 instead of Python 2
    - Testing now depends on any Python 3 interpreter
    - New patch Make-tests-compatible-with-Python-3.patch
  * Fixup the Maintainer and Uploaders fields
    - Move myself from Maintainer to Uploaders
    - Set the Debian Science Team as Maintainer

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sun, 05 Mar 2017 09:17:13 +0000

docopt.cpp (0.6.2-1) unstable; urgency=low

  * Initial release. (Closes: #847384)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 08 Dec 2016 10:52:18 +0000

=== debian/control ===
Source: docopt.cpp
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.1),
               debhelper (>= 10),
               dpkg-dev (>= 1.17.14),
               python3:any <!nocheck>
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/docopt.cpp.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/docopt.cpp.git
Homepage: https://github.com/docopt/docopt.cpp

Package: libdocopt0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: C++11 port of docopt
 With docopt, the option parser is generated based on the program's docstring.
 docopt parses the usage pattern ("Usage: ...") and option descriptions (lines
 starting with dash "-") and ensures that the program invocation matches the
 usage pattern. It parses options, arguments and commands based on that. The
 basic idea is that a good help message has all necessary information in it to
 make a parser.
 .
 This is a port of the docopt Python module to C++ with a focus on maintaining
 full feature parity (and code structure) as the original. The differences from
 the Python port are:
 .
   - The addition of a docopt_parse function, which does not terminate the
     program on error a docopt::value type to hold the various value types that
     can be parsed.
 .
   - Because C++ is statically-typed and Python is not, some changes were made
     to the interfaces of the internal parse tree types.
 .
   - Because std::regex does not have an equivalent to Python's regex.split,
     some of the regex's had to be restructured and additional loops used.
 .
 This package provides the shared libraries.

Package: libdocopt-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libdocopt0 (= ${binary:Version})
Description: development files for docopt.cpp
 With docopt, the option parser is generated based on the program's docstring.
 docopt parses the usage pattern ("Usage: ...") and option descriptions (lines
 starting with dash "-") and ensures that the program invocation matches the
 usage pattern. It parses options, arguments and commands based on that. The
 basic idea is that a good help message has all necessary information in it to
 make a parser.
 .
 This is a port of the docopt Python module to C++ with a focus on maintaining
 full feature parity (and code structure) as the original. The differences from
 the Python port are:
 .
   - The addition of a docopt_parse function, which does not terminate the
     program on error a docopt::value type to hold the various value types that
     can be parsed.
 .
   - Because C++ is statically-typed and Python is not, some changes were made
     to the interfaces of the internal parse tree types.
 .
   - Because std::regex does not have an equivalent to Python's regex.split,
     some of the regex's had to be restructured and additional loops used.
 .
 This package provides the development files.

## docopt.cpp 0.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.1)
-project(docopt.cpp VERSION 0.6.1)
+project(docopt.cpp VERSION 0.6.2)
 
 include(GNUInstallDirs)
 
@@ -20,11 +20,6 @@
 	set(CMAKE_CXX_STANDARD 11)
 endif()
 
-# Suppression of "unknown pragma" warning on GCC
-if(CMAKE_COMPILER_IS_GNUCXX)
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unknown-pragmas") # Code uses #pragma mark
-endif()
-
 #============================================================================
 # Sources & headers
 #============================================================================
@@ -39,40 +34,21 @@
 #============================================================================
 # Compile targets
 #============================================================================
-if(MSVC OR XCODE)
-    # MSVC requires __declspec() attributes, which are achieved via the 
-    # DOCOPT_DLL and DOCOPT_EXPORTS macros below. Since those macros are only
-    # defined when building a shared library, we must build the shared and
-    # static libraries completely separately.
-    # Xcode does not support libraries with only object files as sources.
-    # See https://cmake.org/cmake/help/v3.0/command/add_library.html?highlight=add_library
-    add_library(docopt SHARED ${docopt_SOURCES} ${docopt_HEADERS})
-    add_library(docopt_s STATIC ${docopt_SOURCES} ${docopt_HEADERS})
-else()
-    # If not using MSVC or Xcode, we will create an intermediate object target
-    # to avoid compiling the source code twice.
-    add_library(docopt_o OBJECT ${docopt_SOURCES} ${docopt_HEADERS})
-    set_target_properties(docopt_o PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
-
-    add_library(docopt SHARED $<TARGET_OBJECTS:docopt_o>)
-    add_library(docopt_s STATIC $<TARGET_OBJECTS:docopt_o>)
-endif()
+add_library(docopt ${docopt_SOURCES} ${docopt_HEADERS})
+set_target_properties(docopt PROPERTIES
+  VERSION ${PROJECT_VERSION}
+  SOVERSION ${PROJECT_VERSION_MAJOR}
+)
 
 target_include_directories(docopt PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}> $<INSTALL_INTERFACE:include/docopt>)
-target_include_directories(docopt_s PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}> $<INSTALL_INTERFACE:include/docopt>)
 
-if(MSVC)
+if(MSVC AND BUILD_SHARED_LIBS)
     # DOCOPT_DLL: Must be specified when building *and* when using the DLL.
     #             That's what the "PUBLIC" means.
     # DOCOPT_EXPORTS: Must use __declspec(dllexport) when building the DLL.
     #                 "PRIVATE" means it's only defined when building the DLL.
     target_compile_definitions(docopt PUBLIC  DOCOPT_DLL
                                       PRIVATE DOCOPT_EXPORTS)
-endif()
-
-if(NOT MSVC)
-	set_target_properties(docopt PROPERTIES OUTPUT_NAME docopt)
-	set_target_properties(docopt_s PROPERTIES OUTPUT_NAME docopt)
 endif()
 
 if(USE_BOOST_REGEX)
@@ -83,9 +59,6 @@
     find_package(Boost 1.53 REQUIRED COMPONENTS regex)
     include_directories(${Boost_INCLUDE_DIRS})
     target_link_libraries(docopt ${Boost_LIBRARIES})
-	if(WITH_STATIC)
-		target_link_libraries(docopt_s ${Boost_LIBRARIES})
-	endif()
 endif()
 
 #============================================================================
@@ -118,10 +91,12 @@
 set(export_name "docopt-targets")
 
 # Runtime package
-install(TARGETS docopt EXPORT ${export_name} DESTINATION ${CMAKE_INSTALL_LIBDIR})
+install(TARGETS docopt EXPORT ${export_name}
+	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
 
 # Development package
-install(TARGETS docopt_s EXPORT ${export_name} DESTINATION ${CMAKE_INSTALL_LIBDIR})
 install(FILES ${docopt_HEADERS} DESTINATION include/docopt)
 
 # CMake Package
@@ -129,6 +104,9 @@
 write_basic_package_version_file("${PROJECT_BINARY_DIR}/docopt-config-version.cmake" COMPATIBILITY SameMajorVersion)
 install(FILES docopt-config.cmake ${PROJECT_BINARY_DIR}/docopt-config-version.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/docopt")
 install(EXPORT ${export_name} DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/docopt")
+
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/docopt.pc.in ${CMAKE_CURRENT_BINARY_DIR}/docopt.pc @ONLY)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/docopt.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
 #============================================================================
 # CPack

=== debian/changelog ===
docopt.cpp (0.6.3-4build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:46:11 +0200

docopt.cpp (0.6.3-4) unstable; urgency=medium

  [ Eero Aaltonen ]
  * Fix autopkgtest

 -- Tino Didriksen <tino@didriksen.cc>  Wed, 01 Nov 2023 13:02:05 +0100

docopt.cpp (0.6.3-3) unstable; urgency=medium

  * Patch to increase cmake_minimum_required to 3.5

 -- Tino Didriksen <tino@didriksen.cc>  Wed, 01 Nov 2023 11:45:03 +0100

docopt.cpp (0.6.3-2) unstable; urgency=medium

  * Upload to unstable

 -- Tino Didriksen <tino@didriksen.cc>  Mon, 23 Oct 2023 21:38:04 +0200

docopt.cpp (0.6.3-1) experimental; urgency=medium

  [ Eero Aaltonen ]
  * New upstream release, version 0.6.3 (Closes: #965975)
    - libdocopt-dev now includes a pkgconfig file
    - note: upstream tagged commit does not include version bump,
      but upstream is ok with version increase applied in packaging
      https://github.com/docopt/docopt.cpp/issues/163

  [ Tino Didriksen ]
  * Upgrade Standard-Version to 4.6.2
  * Fix Salsa URLs
  * Only build shared library; drop static library

 -- Tino Didriksen <tino@didriksen.cc>  Fri, 20 Oct 2023 19:09:08 +0200

docopt.cpp (0.6.2-2.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Bump minimum required cmake version to 3.11 to fix autopkgtests
    (Closes: #1040733)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Jul 2023 11:52:23 +0200

docopt.cpp (0.6.2-2.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Uploading to unstable.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Tue, 17 Aug 2021 05:44:44 +0200

docopt.cpp (0.6.2-2.2) experimental; urgency=medium

  * Non-maintainer upload.
  * Including docopt.cpp in /usr/include as referenced in docopt.h
    for packages that need it (Closes: #991256).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 18 Jul 2021 21:20:36 +0200

docopt.cpp (0.6.2-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream patch to fix compilation with GCC 10 (Closes: #957147)

 -- Kunal Mehta <legoktm@debian.org>  Fri, 24 Jul 2020 22:34:42 -0700

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,18 @@
 Source: docopt.cpp
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Tino Didriksen <tino@didriksen.cc>,
+           Eero Aaltonen <eero.aaltonen@vaisala.com>
 Section: libs
 Priority: optional
 Build-Depends: cmake (>= 3.1),
-               debhelper (>= 10),
-               dpkg-dev (>= 1.17.14),
+               debhelper-compat (= 13),
                python3:any <!nocheck>
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/docopt.cpp.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/docopt.cpp.git
+Standards-Version: 4.6.2
+Vcs-Git: https://salsa.debian.org/science-team/docopt.cpp.git
+Vcs-Browser: https://salsa.debian.org/science-team/docopt.cpp
 Homepage: https://github.com/docopt/docopt.cpp
+Rules-Requires-Root: no
 
 Package: libdocopt0
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
ifeq (,$(findstring nocheck,$(DEB_BUILD_PROFILES)))
	dh_auto_configure -- -DWITH_TESTS=ON -DBUILD_SHARED_LIBS=ON
else
	dh_auto_configure -- -DWITH_TESTS=OFF -DBUILD_SHARED_LIBS=ON
endif

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_PROFILES)))
	./*/run_tests
endif

=== debian/tests/control ===
Tests: docopt.cpp-examples
Depends: @, cmake, g++ | c++-compiler

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/docopt.cpp-$1\.tar\.gz/ \
https://github.com/docopt/docopt.cpp/tags .*/v?(\d\S*)\.tar\.gz
